type t

module Map : Map.S with type key = t
module Set : Set.S with type elt = t
  
exception Unsolvable

val name : string
val is_mine_t : Term.t -> bool
val is_mine_r : t -> Term.t Sig.mine
val is_mine_a : Atom.t -> bool
val normal_form : Atom.t -> Atom.t
  
val make : Term.t -> t
val leaves : t -> Term.Set.t
val subst : Term.t -> t -> t -> t
  
val compare : t -> t -> int
  
val solve : t -> t ->  (Term.t * t) list
  
val print : Format.formatter -> t -> unit
  
module R : Sig.RELATION with type elt = t
