type t = 
    | Tint
    | Treal
    | Tbool
    | Tvar of tvar
    | Text of t list * Hstring.t
and tvar = { v : int ; mutable value : t option }

type subst

val esubst : subst

exception TypeClash of t*t

val tunit : t

val text : t list -> string -> t

val shorten : t -> t

val fresh_var : unit -> tvar
val fresh_empty_text : unit -> t

val equal : t -> t -> bool
val hash : t -> int

val unify : t -> t -> unit
val matching : subst -> t -> t -> subst

val apply_subst : subst -> t -> t

val print : Format.formatter -> t -> unit
val printl : Format.formatter -> t list -> unit
